// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package view;

import model.Field;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.CustomNode;
import javafx.scene.shape.Line;
import javafx.scene.paint.Color;

public class FieldNode extends CustomNode {

    public-init var field: Field;
    def BLOCK: Integer = 10;
    public def WIDTH: Number = field.COLUMNS * BLOCK + 1;
    public def HEIGHT: Number = field.ROWS * BLOCK + 1;
    def MIN_X: Integer = 0;
    def MIN_Y: Integer = 0;
    def MAX_X: Integer = field.COLUMNS * BLOCK;
    def MAX_Y: Integer = field.ROWS * BLOCK;
    def converter: CoordinateConverter = FieldCoordinateConverter {
                BLOCK: BLOCK,
            };
    def worm: WormNode = WormNode { worm: field.worm, converter: converter };
    def goody: GoodyNode = GoodyNode { goody: field.goody, converter: converter };

    override function create(): Node {
        return Group {
                    content: [worm, createRows(), createColumns(), goody]
                }
    }

    function createRows(): Node[] {
        return for (row in [0..field.ROWS]) {
                    def y = converter.modelToScreenY(row);
                    Line {
                        startX: MIN_X;
                        startY: y;
                        endX: MAX_X;
                        endY: y;
                        stroke: Color.BLACK;
                    }
                };
    }

    function createColumns(): Node[] {
        return for (col in [0..field.COLUMNS]) {
                    def x = converter.modelToScreenX(col);
                    Line {
                        startX: x;
                        startY: MIN_Y;
                        endX: x;
                        endY: MAX_Y;
                    }
                };
    }

}

class FieldCoordinateConverter extends CoordinateConverter {

    public-init var BLOCK;

    public override function modelToScreenX(modelX: Integer): Number {
        return modelX * BLOCK;
    }

    public override function modelToScreenY(modelY: Integer): Number {
        return modelY * BLOCK;
    }

    public override function modelToScreenWidth(width: Integer): Number {
        return width * BLOCK;
    }

    public override function modelToScreenHeight(height: Integer): Number {
        return height * BLOCK;
    }

}

